<template>
  <div ref="globeContainer" v-globe-directive></div>
</template>

<script setup lang="ts">
// Librairies
import { onMounted, onUnmounted, ref } from 'vue'
import Globe from 'globe.gl'
import * as THREE from 'three'
import * as topojson from 'topojson-client'
import { getEffectiveTypeParameterDeclarations } from 'typescript'
// import { GeometryObject, Topology } from 'topojson-specification'

// TypeScript GeoJsonFeature
interface GeoJsonFeature {
  type: string
  features?: any[]
}

// REF
// Ref 1 - Reference of globe Container
const globeContainer = ref<HTMLElement | null>(null)

// VARIABLES
// Variable 1 - globe initialization
let globe: any | null = null
// Variable 2 : random number of sticks
const N = 300
// Variable 3 : collision risk data points
const gData = [...Array(N).keys()].map(() => ({
  lat: (Math.random() - 0.5) * 180,
  lng: (Math.random() - 0.5) * 360,
  size: Math.random() / 3,
  color: ['red', 'white', 'blue', 'green'][Math.round(Math.random() * 3)]
}))

// Variable 4 : globe visualization
const vGlobeDirective = {
  mounted(globe_div: any, binding: any, vnode: any, prevVnode: any) {
    if (globe_div) {
      globe = Globe()(globe_div)
        .pointsData(gData)
        .pointAltitude('size')
        .pointColor('color')
        .backgroundColor('rgba(255, 255, 255, 1)')
        .showGlobe(true)
        .showAtmosphere(false)

      // const now_utc_unix = Math.floor(new Date().getTime() / 1000)

      // const max_alt = 6000
      // const min_alt = 50
      // const max_scale = 1.0
      // const min_scale = 0.05
      // const radius_past = 0.35
      // const radius_min = 0.8
      // const radius_max = 2.8
      // const seven_days_seconds = 3600 * 24 * 7

      // // Const globe options
      // const globeMaterial = globe.globeMaterial()
      // globeMaterial.specular = new THREE.Color('grey')
      // globeMaterial.color.set(0xa2a9f8)
      // globeMaterial.flatshading = false

      // Add Auto-Rotation
      globe.controls().autoRotate = true
      globe.controls().autoRotateSpeed = 0.2

      // --- Fetch data in parallel
      Promise.all([
        fetch('/static/data/land-110m.json').then((res) => res.json()),
        fetch('/static/data/cdm-v0.json').then((res) => res.json())
      ]).then(([land, cdms]) => {
        try {
          // Récupération de l'objet feature
          const feature = topojson.feature(land, land.objects.land) as GeoJsonFeature

          // Récupération de l'array features
          const features = feature?.features || []
          console.log('Feature : ', feature)

          // Migrate lighting according to the guide
          const light = new THREE.AmbientLight(0x404040, 3)
          globe.scene().add(light)

          // Release visual globe
          globe
            .polygonsData(features)
            .polygonCapMaterial(
              new THREE.MeshLambertMaterial({
                color: 'rgba(139, 149, 246, 1)',
                side: THREE.DoubleSide
              })
            )
            .polygonSideColor(() => 'rgba(255, 255, 255, 1)')
        } catch (error) {
          console.error("Une erreur s'est produite lors du traitement des données : ", error)
        }
      })
    }
  }
}

// Méthode 2 - resizeHandler (listening resizing event)
const resizeHandler = () => {
  try {
    if (globeContainer.value && globe) {
      const { clientWidth: width, clientHeight: height } = globeContainer.value
      globe.width([width])
      globe.height([height])
    }
  } catch (error) {
    console.error("We've got an error: ", error)
  }
}

// ComponentDidMount
onMounted(() => {
  // add event resize event listener
  window.addEventListener('resize', resizeHandler)
})

// Clean resize event listener while ComponentDidUnmount
onUnmounted(() => {
  window.removeEventListener('resize', resizeHandler)
})
</script>
